package main

import (
	"log"
	"os"
	"sorbet/cmd/commands"

	"github.com/urfave/cli/v2"
)

var app = &cli.App{
	Name:  "sorbet",
	Usage: "sorbet scaffold",
	Commands: []*cli.Command{
		{
			Name:  "secret",
			Usage: "Builds a ticket private/public keys",
			Action: func(c *cli.Context) error {
				g := new(commands.TicketKeysGenerator)
				return g.Generate()
			},
		},
	},
}

func main() {
	if err := app.Run(os.Args); err != nil {
		log.Fatal(err)
	}
}
