package entities

import (
	"gorm.io/gorm"
	"sorbet/pkg/db"
	"time"
)

// FeatureConfig 栏目配置表
type FeatureConfig struct {
	ID            uint           `json:"id"             xml:"id"             gorm:"primaryKey;not null;comment:配置编号"`
	FeatureID     uint           `json:"feature_id"     xml:"feature_id"     gorm:"comment:所属栏目编号"`
	Status        bool           `json:"status"         xml:"status"         gorm:"comment:是否启用分类功能"`
	Categorizable bool           `json:"categorizable"  xml:"categorizable"  gorm:"comment:是否启用分类功能"`
	CategoryDepth int64          `json:"category_depth" xml:"category_depth" gorm:"comment:最大分类层级数"`
	ContentTypes  []string       `json:"content_types"  xml:"content_types"  gorm:"serializer:json;comment:支持的内容类型"`
	Version       db.Version     `json:"-"              xml:"-"              gorm:"comment:乐观锁"`
	CreatedAt     time.Time      `json:"create_time"    xml:"create_time"    gorm:"<-:false;comment:创建时间"`
	UpdatedAt     time.Time      `json:"update_time"    xml:"update_time"    gorm:"<-:false;comment:更新时间"`
	DeletedAt     gorm.DeletedAt `json:"-"              xml:"-"              gorm:"comment:删除时间"`
}
