package bus

import (
	"context"
	"sync"
)

type Listener func(ctx context.Context, event Event)

type ListenerObject struct {
	async bool
	once  *sync.Once
	do    Listener
	ptr   uintptr
}

type ListenOption func(*ListenerObject)

func WithAsync(async bool) ListenOption {
	return func(o *ListenerObject) {
		o.async = async
	}
}

func WithOnce(once bool) ListenOption {
	return func(o *ListenerObject) {
		if !once && o.once != nil {
			o.once = nil
		} else if once && o.once == nil {
			o.once = new(sync.Once)
		}
	}
}
